<?php


class sllimboShortcodes {



	public function __construct() {

		add_shortcode( 'article-count', array( $this, 'article_count' ) );
		add_shortcode( 'member-number', array( $this, 'member_number' ) );
		add_shortcode( 'monthly-price', array( $this, 'price' ) );
		add_shortcode( 'payments',      array( $this, 'payments' ) );
		add_shortcode( 'phrase',        array( $this, 'phrase' ) );
		add_shortcode( 'subscribe',     array( $this, 'subscribe' ) );

	}



	function clean_shortcode( $content ) {

		if ( '</p>' == substr( $content, 0, 4 ) and '<p>' == substr( $content, strlen( $content ) - 3 ) )
			$content = substr( $content, 4, strlen( $content ) - 7 );

		return $content;

	}



	function member_number() {

		global $current_user;

		get_currentuserinfo();

		return $current_user->ID;

	}



	function article_count() {

		return sllimbo::article_count();

	}



	function payments() {

		global $current_user;

		get_currentuserinfo();

		$args = array(
			'post_type'      => 'payment',
			'post_status'    => 'publish',
			'posts_per_page' => -1,
			'meta_query'     => array(
				array(
					'key'   => 'sllimbo-payment-subscriber-id',
					'value' => $current_user->ID
					)
				)
			);

		$payments = get_posts( $args );

		if ( $payments ) {
			$out = '<table class="payments-table">';
			$out .= '<thead>';
			$out .= '<tr>';
			$out .= '<th scope="col">Date</th>';
			$out .= '<th scope="col">Amount</th>';
			$out .= '<th scope="col">Transaction ID</th>';
			$out .= '<th scope="col">Type</th>';
			$out .= '</tr>';
			$out .= '</thead>';
			$out .= '<tbody>';
			$i = 'even';
			foreach ( $payments as $payment ) {
				$i = ( 'odd' == $i ) ? 'even' : 'odd';
				$out .= sprintf( '<tr class="row-%s">', $i );
				$out .= sprintf(
					'<td>%s</td><td>%s</td><td>%s</td>',
					mysql2date( get_option( 'date_format' ), $payment->post_date ),
					sllimbo::custom( 'payment-amount', array( 'post_id' => $payment->ID ) ),
					sllimbo::custom( 'payment-transaction-id', array( 'post_id' => $payment->ID ) )
					);
				$type = sllimbo::get_payment_type( $payment->ID );
				$out .= sprintf( '<td>%s</td>', $type );
				$out .= '</tr>';
			}
			$out .= '</tbody>';
			$out .= '</table>';
		} else {
			$out = '<p>No payments received.</p>';
		}

		return $out;

	}



	function phrase( $atts ) {

		extract( shortcode_atts( array( 'term' => null, 'alt' => null, 'synonym' => null, 'def' => null ), $atts ) );

		if ( !$term or !$def )
			return;

		if ( is_single() ) {

			$term_link = sanitize_title_with_dashes( $term );

			$html = sprintf(
						'<a id="sllimbo-phrase-%s" href="#sllimbo-def-%s" title="View the definition of &quot;%s&quot;" class="sllimbo-phrase-link">%s</a>',
						$term_link,
						$term_link,
						( $alt ? esc_attr( $alt ) : esc_attr( $term ) ),
						esc_html( $term )
						);

		} else {

			$html = sprintf(
						'<span class="sllimbo-phrase">%s</span>',
						esc_html( $term )
						);

		}

		return $html;

	}



	function price() {

		return get_site_preference( 'cost' );

	}



	function subscribe() {

		return sllimbo::signup_button();

	}



}



$sllimbo_shortcodes = new sllimboShortcodes;



?>