<?php
class sllimboToolbar {



	public function __construct() {

		add_action( 'wp_before_admin_bar_render', array( $this, 'cleanup' ), 999 );
		add_filter( 'show_admin_bar',             array( $this, 'visibility' ) );

	}



	function cleanup() {

		if ( ! is_admin_bar_showing() )
			return;

		if ( current_user_can( 'use_wordpress_admin' ) )
			return;

		global $wp_admin_bar;

		$wp_admin_bar->remove_node( 'wp-logo' );
		$wp_admin_bar->remove_node( 'comments' );
		$wp_admin_bar->remove_node( 'search' );
		$wp_admin_bar->remove_node( 'new-media' );
		$wp_admin_bar->remove_node( 'view-media' );
		$wp_admin_bar->remove_node( 'view-attachment' );

		if ( ( is_home() or is_front_page() ) and is_user_logged_in() ) {
			$wp_admin_bar->remove_node( 'edit' );
		}

	}



	function visibility() {

		if ( ! current_user_can( 'edit_posts' ) ) {
			return false;
		}

		return true;

	}



}



$sllimbo_toolbar = new sllimboToolbar;



?>